import sjcl from 'sjcl'

class CryptoConversions {
  // Contains functions for converting some data, used during encryption and decryption

  fromBitArrayCodec (arr) {
    // Convert from a bitArray to an array of bytes.
    let out = []
    let bl = sjcl.bitArray.bitLength(arr)
    let i
    let tmp
    for (i = 0; i < bl / 8; i++) {
      if ((i & 3) === 0) {
        tmp = arr[i / 4]
      }
      out.push(tmp >>> 24)
      tmp <<= 8
    }
    return out
  }

  toBitArrayCodec (bytes) {
    // Convert from an array of bytes to a bitArray
    let out = []
    let i
    let tmp = 0
    for (i = 0; i < bytes.length; i++) {
      tmp = tmp << 8 | bytes[i]
      if ((i & 3) === 3) {
        out.push(tmp)
        tmp = 0
      }
    }
    if (i & 3) {
      out.push(sjcl.bitArray.partial(8 * (i & 3), tmp))
    }
    return out
  }

  randomWordsToCrypto (words) { // Convert words generated by SJCL to WebCrypto format
    return new Int32Array(words).buffer
  }

  arrayBufferToBitArray (buf) {
    let i, l, len, inView, tmp
    let out = []
    if (buf.byteLength === 0) return []
    inView = new DataView(buf)
    len = inView.byteLength - inView.byteLength % 4
    for (i = 0; i < len; i += 4) {
      out.push(inView.getUint32(i))
    }
    if (inView.byteLength % 4 !== 0) {
      tmp = new DataView(new ArrayBuffer(4))
      for (i = 0, l = inView.byteLength % 4; i < l; i++) {
        // we want the data to the right, because partial slices off the starting bits
        tmp.setUint8(i + 4 - l, inView.getUint8(len + i)) // big-endian,
      }
      out.push(
        sjcl.bitArray.partial((inView.byteLength % 4) * 8, tmp.getUint32(0))
      )
    }
    return out
  }

  bitArrayToArrayBuffer (arr) {
    // Convert a bitArray used by SJCL to an ArrayBuffer (used by WebCrypto)
    let out, i, ol, tmp, smallest
    let padding = true
    let paddingCount = 8
    if (arr.length === 0) return new ArrayBuffer(0)
    ol = sjcl.bitArray.bitLength(arr) / 8
    // check to make sure the bitLength is divisible by 8, if it isn't
    // we can't do anything since arraybuffers work with bytes, not bits
    if (sjcl.bitArray.bitLength(arr) % 8 !== 0) {
      throw new sjcl.exception.invalid('Invalid bit size, must be divisble by 8 to fit in an arraybuffer correctly') // eslint-disable-line new-cap
    }
    if (padding && ol % paddingCount !== 0) {
      ol += paddingCount - (ol % paddingCount)
    }
    // padded temp for easy copying
    tmp = new DataView(new ArrayBuffer(arr.length * 4))
    for (i = 0; i < arr.length; i++) {
      tmp.setUint32(i * 4, (arr[i] << 32)) // get rid of the higher bits
    }
    // now copy the final message if we are not going to 0 pad
    out = new DataView(new ArrayBuffer(ol))
    // save a step when the tmp and out bytelength are ===
    if (out.byteLength === tmp.byteLength) return tmp.buffer
    smallest = tmp.byteLength < out.byteLength ? tmp.byteLength : out.byteLength
    for (i = 0; i < smallest; i++) {
      out.setUint8(i, tmp.getUint8(i))
    }
    return out.buffer
  }

  arrayBufferToB64 (buf) {
    return sjcl.codec.base64.fromBits(this.arrayBufferToBitArray(buf))
  }

  wordToB64 (w) {
    return sjcl.codec.base64.fromBits(Array.prototype.slice.call(new Int32Array(w))) // Int32 instead Uint32
  }

  b64ToArrayBuffer (str, lastChunk = false) {
    let uint8 = new Uint8Array(this.bitArrayToArrayBuffer(sjcl.codec.base64.toBits(str)))
    if (!lastChunk) return uint8.buffer
    let i
    for (i = uint8.length - 1; i >= 0; i--) { // Remove '0' at the end
      if (uint8[i] !== 0) break
    }
    return uint8.slice(0, i + 1).buffer
  }

  b64toWord (str) {
    return new Int32Array(sjcl.codec.base64.toBits(str)).buffer
  }
}

export default new CryptoConversions()
